mtl-1.1.1.0: Monad transformer library

Portability | non-portable (multi-param classes, functional dependencies)
Stability | experimental
Maintainer | libraries@haskell.org

Control.Monad.State.Lazy

Contents

- The State Monad
- The StateT Monad
- Examples

Description

Lazy state monads.

This module is inspired by the paper /Functional Programming with Overloading and Higher-Order Polymorphism/, Mark P Jones (http://web.cecs.pdx.edu/~mpj/) Advanced School of Functional Programming, 1995.

See below for examples.

Synopsis

- module Control.Monad.State.Class
- newtype State s a = State {
  - runState :: s -> (a, s)
  }
- evalState :: State s a -> s -> a
- execState :: State s a -> s -> s
- mapState :: ((a, s) -> (b, s)) -> State s a -> State s b
- withState :: (s -> s) -> State s a -> State s a
- newtype StateT s m a = StateT {
  - runStateT :: s -> m (a, s)
  }
- evalStateT :: Monad m => StateT s m a -> s -> m a
- execStateT :: Monad m => StateT s m a -> s -> m s
- mapStateT :: (m (a, s) -> n (b, s)) -> StateT s m a -> StateT s n b
- withStateT :: (s -> s) -> StateT s m a -> StateT s m a
- module Control.Monad
- module Control.Monad.Fix
- module Control.Monad.Trans

# Documentation

module Control.Monad.State.Class

# The State Monad

newtype State s a

A parameterizable state monad where s is the type of the state to carry and a is the type of the return value.

Constructors

State |

Fields

runState :: s -> (a, s)

Instances

MonadState s (State s) |
Monad (State s) |
Functor (State s) |
MonadFix (State s) |

evalState

Arguments

:: State s a | The state to evaluate
-> s | An initial value
-> a | The return value of the state application

Evaluate this state monad with the given initial state,throwing away the final state. Very much like `fst` composed with `runstate`.

execState

Arguments

:: State s a | The state to evaluate
-> s | An initial value
-> s | The new state

Execute this state and return the new state, throwing away the return value. Very much like `snd` composed with `runstate`.

mapState :: ((a, s) -> (b, s)) -> State s a -> State s b

Map a stateful computation from one (return value, state) pair to another. For instance, to convert numberTree from a function that returns a tree to a function that returns the sum of the numbered tree (see the Examples section for numberTree and sumTree) you may write:

     sumNumberedTree :: (Eq a) => Tree a -> State (Table a) Int
     sumNumberedTree = mapState (\ (t, tab) -> (sumTree t, tab))  . numberTree

withState :: (s -> s) -> State s a -> State s a

Apply this function to this state and return the resulting state.

# The StateT Monad

newtype StateT s m a

A parameterizable state monad for encapsulating an inner monad.

The StateT Monad structure is parameterized over two things:

- s - The state.
- m - The inner monad.

Here are some examples of use:

(Parser from ParseLib with Hugs)

      type Parser a = StateT String [] a
         ==> StateT (String -> [(a,String)])

For example, item can be written as:

       item = do (x:xs) <- get
              put xs
              return x

       type BoringState s a = StateT s Indentity a
            ==> StateT (s -> Identity (a,s))

       type StateWithIO s a = StateT s IO a
            ==> StateT (s -> IO (a,s))

       type StateWithErr s a = StateT s Maybe a
            ==> StateT (s -> Maybe (a,s))

Constructors

StateT |

Fields

runStateT :: s -> m (a, s)

Instances

MonadWriter w m => MonadWriter w (StateT s m) |
MonadError e m => MonadError e (StateT s m) |
Monad m => MonadState s (StateT s m) |
MonadReader r m => MonadReader r (StateT s m) |
MonadTrans (StateT s) |
Monad m => Monad (StateT s m) |
Monad m => Functor (StateT s m) |
MonadFix m => MonadFix (StateT s m) |
MonadPlus m => MonadPlus (StateT s m) |
MonadIO m => MonadIO (StateT s m) |
MonadCont m => MonadCont (StateT s m) |

evalStateT :: Monad m => StateT s m a -> s -> m a

Similar to `evalState`

execStateT :: Monad m => StateT s m a -> s -> m s

Similar to `execState`

mapStateT :: (m (a, s) -> n (b, s)) -> StateT s m a -> StateT s n b

Similar to `mapState`

withStateT :: (s -> s) -> StateT s m a -> StateT s m a

Similar to `withState`

module Control.Monad

module Control.Monad.Fix

module Control.Monad.Trans

# Examples

A function to increment a counter. Taken from the paper Generalising Monads to Arrows, John Hughes (http://www.math.chalmers.se/~rjmh/), November 1998:

     tick :: State Int Int
     tick = do n <- get
               put (n+1)
               return n

Add one to the given number using the state monad:

     plusOne :: Int -> Int
     plusOne n = execState tick n

A contrived addition example. Works only with positive numbers:

     plus :: Int -> Int -> Int
     plus n x = execState (sequence $ replicate n tick) x

An example from The Craft of Functional Programming, Simon Thompson (http://www.cs.kent.ac.uk/people/staff/sjt/), Addison-Wesley 1999: "Given an arbitrary tree, transform it to a tree of integers in which the original elements are replaced by natural numbers, starting from 0. The same element has to be replaced by the same number at every occurrence, and when we meet an as-yet-unvisited element we have to find a 'new' number to match it with:"

     data Tree a = Nil | Node a (Tree a) (Tree a) deriving (Show, Eq)
     type Table a = [a]

     numberTree :: Eq a => Tree a -> State (Table a) (Tree Int)
     numberTree Nil = return Nil
     numberTree (Node x t1 t2)
            =  do num <- numberNode x
                  nt1 <- numberTree t1
                  nt2 <- numberTree t2
                  return (Node num nt1 nt2)
         where
         numberNode :: Eq a => a -> State (Table a) Int
         numberNode x
            = do table <- get
                 (newTable, newPos) <- return (nNode x table)
                 put newTable
                 return newPos
         nNode::  (Eq a) => a -> Table a -> (Table a, Int)
         nNode x table
            = case (findIndexInList (== x) table) of
              Nothing -> (table ++ [x], length table)
              Just i  -> (table, i)
         findIndexInList :: (a -> Bool) -> [a] -> Maybe Int
         findIndexInList = findIndexInListHelp 0
         findIndexInListHelp _ _ [] = Nothing
         findIndexInListHelp count f (h:t)
            = if (f h)
              then Just count
              else findIndexInListHelp (count+1) f t

numTree applies numberTree with an initial state:

     numTree :: (Eq a) => Tree a -> Tree Int
     numTree t = evalState (numberTree t) []

     testTree = Node "Zero" (Node "One" (Node "Two" Nil Nil) (Node "One" (Node "Zero" Nil Nil) Nil)) Nil
     numTree testTree => Node 0 (Node 1 (Node 2 Nil Nil) (Node 1 (Node 0 Nil Nil) Nil)) Nil

sumTree is a little helper function that does not use the State monad:

     sumTree :: (Num a) => Tree a -> a
     sumTree Nil = 0
     sumTree (Node e t1 t2) = e + (sumTree t1) + (sumTree t2)